use FindBin;
use lib "$FindBin::Bin/lib";
use Test2::V0;

use MyApp::DB;
use MyApp::User;

my $user   = MyApp::User->new(name => 'Anonymous');
my $config = do './.anego.pl';
my $db     = MyApp::DB->new(connect_info => $config->{connect_info});

is $user->hp, 0;
is $user->mp, 0;

subtest 'ポーションを使う' => sub {
    my $potion = $db->select(item => +{ name => 'potion' })->first;
    # アイテム名に基づいてアイテム効果クラスのモジュールをロードし、アイテムの効果を発動します
    $potion->use($user); 
    is $user->hp, 10;
};

subtest 'エーテルを使う' => sub {
    my $ether = $db->select(item => +{ name => 'ether' })->first;
    $ether ->use($user);
    is $user->mp, 10;
};

subtest 'エリクサーを使う' => sub {
    my $elixir = $db->select(item => +{ name => 'elixir' })->first;
    $elixir->use($user);
    is $user->hp, 20;
    is $user->mp, 20;
};

done_testing;
