package MyApp::Model::DB::Countries;
use strict;
use warnings;
use utf8;
use Moose;
use MyApp::DB;

extends 'Catalyst::Model';

has db => (
    is      => 'ro',
    isa     => 'MyApp::DB',
    lazy    => 1,
    default => sub {
        my $config = do '.anego.pl';
        MyApp::DB->new(connect_info => $config->{connect_info});
    },
);

sub search {
    my ($self, $options) = @_;
    $self->db->select(countries => $options)->first;
}

1;
