package MyApp::DB::Row::Item;
use 5.014002;
use Mouse v2.4.5;
use Class::Load qw( load_class );
use String::CamelCase qw( camelize );

use MyApp::ItemEffect::Potion;
use MyApp::ItemEffect::Ether;
use MyApp::ItemEffect::Elixir;

extends qw/ MyApp::DB::Row /;

sub use {
    my ($self, $user) = @_;

    state %effect_module_of = (
        potion => 'MyApp::ItemEffect::Potion',
        ether  => 'MyApp::ItemEffect::Ether',
        elixir => 'MyApp::ItemEffect::Elixir',
    );

    my $module = $effect_module_of{ $self->name };
    my $effect = $module->new(@_);
    $effect->execute($user);
}

1;
