package MyApp::User;

use strict;
use warnings;
use utf8;
use Moo;
use Types::Standard qw( Int Str );
use Type::Utils qw( class_type );

use MyApp::User::HP;
use MyApp::User::MP;

has name => (
    is       => 'ro',
    isa      => Str,
    required => 1,
);

has hp => (
    is      => 'rw',
    isa     => class_type('MyApp::User::HP'),
    default => sub { MyApp::User::HP->new },
);

has mp => (
    is      => 'rw',
    isa     => class_type('MyApp::User::MP'),
    default => sub { MyApp::User::MP->new },
);

__PACKAGE__->meta->make_immutable;

1;
