package MyApp::User::MP;
use strict;
use warnings;
use utf8;
use Moo;
use Types::Standard qw( Int );
use List::Util qw( min );

use constant MAX => 100;

use overload (
    '0+'     => 'as_num',
    fallback => 1,
);

has num => (
    is      => 'ro',
    isa     => Int,
    default => 0,
);

sub add {
    my ($self, $num) = @_;
    my $result = min($self->num + $num, MAX);
    (ref $self)->new(num => $result);
}

sub as_num { shift->num }

__PACKAGE__->meta->make_immutable;

1;
